------------------------------------------------------------
revno: 9823
revision-id: squid3@treenet.co.nz-20091216005119-cl6tw24f7sa1h3mg
parent: squid3@treenet.co.nz-20091206103947-diofb5tc4rvvphuc
committer: Amos Jeffries <squid3@treenet.co.nz>
branch nick: SQUID_3_1
timestamp: Wed 2009-12-16 13:51:19 +1300
message:
  Bug 2830: clarify where NULL byte is in headers.
  
  Debug printing used to naturally stop string output at the null byte.
  
  This should show the first segment of headers up to the NULL and the
  segment of headers after it. So that its clear to admin that there are
  more headers _after_ the portion that used to be logged.
------------------------------------------------------------
# Bazaar merge directive format 2 (Bazaar 0.90)
# revision_id: squid3@treenet.co.nz-20091216005119-cl6tw24f7sa1h3mg
# target_branch: http://www.squid-cache.org/bzr/squid3/trunk/
# testament_sha1: 5dfea26713ac7d2e838cc1b87124566ec717b3a4
# timestamp: 2009-12-16 01:15:26 +0000
# source_branch: http://www.squid-cache.org/bzr/squid3/branches\
#   /SQUID_3_1
# base_revision_id: squid3@treenet.co.nz-20091206103947-\
#   diofb5tc4rvvphuc
# 
# Begin patch
=== modified file 'src/HttpHeader.cc'
--- src/HttpHeader.cc	2009-09-03 12:15:55 +0000
+++ src/HttpHeader.cc	2009-12-16 00:51:19 +0000
@@ -514,9 +514,10 @@
     debugs(55, 7, "parsing hdr: (" << this << ")" << std::endl << getStringPrefix(header_start, header_end));
     HttpHeaderStats[owner].parsedCount++;
 
-    if (memchr(header_start, '\0', header_end - header_start)) {
+    char *nulpos;
+    if ((nulpos = (char*)memchr(header_start, '\0', header_end - header_start))) {
         debugs(55, 1, "WARNING: HTTP header contains NULL characters {" <<
-               getStringPrefix(header_start, header_end) << "}");
+               getStringPrefix(header_start, nulpos) << "}\nNULL\n{" << getStringPrefix(nulpos+1, header_end));
         goto reset;
     }
 

